/* errors.c  -  ProSum Errors Identification
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "errors.h"

int value_err(int error) {
  switch (error) {
#ifdef SYSCALL_SUPPORT
    case ENOSYSCALL:
               printf(_("Can't Get sys_call_table[] Address\n"));
               return SUCCESS;
#endif
    case ENOALIAS:
               printf(_("Alias Name Does NOT Exists On Bastion Host\n"));
               return SUCCESS;
    case ENODUPA:
               printf(_("Alias Already Exists On Bastion Host\n"));
               return SUCCESS;
    case ENOVERSION:
               printf(_("The server isn't ProSum or is a different version than the client\n"));
               return SUCCESS;
    case ENOCMD:
               printf(_("Unknown Command\n"));
               return SUCCESS;
    case ENORECV:
               printf(_("Error While Recibing File\n"));
               return SUCCESS;
    case ENOSEND:
               printf(_("Error While Sending File\n"));
               return SUCCESS;
    default:
               return ERROR;
  }
}
