/* idt.h
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _IDT_H
#define _IDT_H

#include "common.h"
#include "kmem.h"
#include <asm/segment.h>

extern int put_idt(table_t *idt_tbl);
//Rellena la tabla con la IDT y en caso satisfactorio devuelve SUCCESS o ERROR en caso de fallo

extern char *value_segment(unsigned short segment);
//Devuelve el segmento al que pertenece la interrupcion

extern int check_idt(idt_t *orig, idt_t *cmp);
//Chequea la direccion de la IDT, devuelve ERROR en caso de fallo

extern int restore_idt(idt_t *st);
//Restaura la IDT segun la estructura

#endif
