/* kmem.h
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _KMEM_H
#define _KMEM_H

#include "common.h"

struct {
        unsigned short limit;
        unsigned int base;
} __attribute__ ((packed)) idtr;

struct {
        unsigned short off1;
        unsigned short sel;
        unsigned char none, flags;
        unsigned short off2;
} __attribute__ ((packed)) idt;

extern unsigned long get_idt_addr(unsigned short *size);
//Devuelve la direccion de la IDT y mete el tamao en el argumento, si el 
//argumento es NULL no mete el tamao

extern int readkmem(int fd, void *buf, unsigned offset, int size);
//Lee un dato de fd devuelve SUCCESS si todo va bien o ERROR en caso de que falle

extern int writekmem(int fd, void *buf, unsigned offset, int size);
//Igual que readkmem pero escribe

#endif
