/* stat.c  -  Stat Attributes Manipulation
 *      Copyright (C) 2002 fkt <fkt@funfatal.org>
 *
 * This file is part of ProSum.
 *
 * ProSum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ProSum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "stat.h"

#define PUT_ERR(i) do { \
                     err=ERROR; \
                     err_buf[i]=ERROR; \
                   } while(0);

int do_stat(file_t *f_st) {
  if (stat(f_st->filename,&(f_st->f_status)))
    return ERROR;

  return SUCCESS;
}

int check_stat(struct stat *st, struct stat *cmp, err_buf_t err_buf) {
  int err=SUCCESS;

  if (st->st_mode != cmp->st_mode) PUT_ERR(0);
  if (st->st_uid != cmp->st_uid) PUT_ERR(1);
  if (st->st_gid != cmp->st_gid) PUT_ERR(2); 
  if (st->st_size != cmp->st_size) PUT_ERR(3);

#ifdef IS_BSD
  if (st->st_mtimespec.tv_sec != cmp->st_mtime) PUT_ERR(4);
#else
  if (st->st_mtime != cmp->st_mtime) PUT_ERR(4);
#endif

  return err;
}
